package simpleanimation;

import javax.swing.*;

import java.awt.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;

public class CrazyAnimationApp extends JFrame {
	
	public CrazyAnimationApp (String title){
		super(title);
		this.setSize(800, 600);
		this.setDefaultCloseOperation(EXIT_ON_CLOSE);
		//add code for the content of this frame here
		SimpleShapeContainer p=new SimpleShapeContainer();	
		p.setBackground(new Color(176, 196,222));
		
		
		//1. adding SmartRectangularShapes: ellipse, rectangle, arc
		SmartRectangularShape ball=new SmartEllipse();
		ball.setFillColor(Color.BLUE);
		ball.setSize(50, 50);
		ball.setLocation(75, 75);
	
		p.addShape(ball);		
	
		SmartRectangularShape box=new SmartRectangle();
		box.setFillColor(Color.GREEN);
		box.setSize(100, 40);
		box.setLocation(175, 175);
	
		p.addShape(box);
	
		SmartRectangularShape arc=new SmartArc(200,300,Arc2D.PIE);
		arc.setStrokeWidth(2);
		arc.setBorderColor(Color.BLACK);
		arc.setFillColor(Color.RED);
		arc.setSize(50, 60);
		arc.setLocation(200, 200);	
	
		p.addShape(arc);
	
		//2. adding SmartIcon
		SmartIcon img=null;
		try 
		{
			BufferedImage bi = ImageIO.read(new File("star.png"));
			img=new SmartIcon(bi);
			img.setLocation(200, 200);
			img.setSize(bi.getWidth(), bi.getHeight());
			p.addShape(img);
		} 
		catch (IOException e) { e.printStackTrace(); }
	
		//3. adding smart text
		Font font = new Font("Serif", Font.PLAIN, 22);	
		SmartText textShape=new SmartText("Hello, world",font);
		textShape.setLocation(30, 30);
		p.addShape(textShape);
	
		//4. Adding fISH sHAPE
		FishShape fish=new FishShape(44,20,Color.YELLOW);
		fish.setLocation(0, 90);
		
		p.addShape(fish);
		
		this.add(p);
		this.setVisible(true);
	
		Timer timer=new Timer(100, new BouncingBallAnimationListener(ball, 20, this));
		timer.addActionListener(new BouncingBallAnimationListener(box, 30, this));
		timer.addActionListener(new FishAnimationListener(arc, 15, this));
		if(img!=null)
			timer.addActionListener(new BouncingBallAnimationListener(img, 5, this));
		timer.addActionListener(new FishAnimationListener(textShape, 25, this));
		timer.addActionListener(new FishAnimationListener(fish, 25, this));
		timer.start();
		
	}
	
	public static void main (String [] args)
	{
		JFrame f=new CrazyAnimationApp("Crazy animated shapes");	
		
	}
}
