package simpleanimation;
import java.awt.*;
import java.awt.font.*;

public class SmartText implements SimpleShape{
	private int posX,posY;
	private int width=-1, height=-1;
	private double rotation;
	
	Font font;
	String text;
	FontRenderContext frc;
	
	public SmartText(String text, Font font)
	{
		this.text=text;
		this.font=font;
	}
	
	public void setLocation (int posX, int posY)
	{
		this.posX=posX;
		this.posY=posY;
	}
	
	public void setSize (int width, int height)	
	{
		if(frc!=null && this.width==-1 && this.height==-1)  //we have a context and the variables have been not initialized yet
		{			
			this.width=(int)this.font.getStringBounds(this.text, frc).getBounds2D().getWidth();
			this.height=(int)this.font.getStringBounds(this.text, frc).getBounds2D().getHeight();
		}
	}
		
	public void changeLocation (int stepX, int stepY)
	{
		this.posX+=stepX;
		this.posY+=stepY;
	}
	
	
	//method to paint the shape
	public void paint(java.awt.Graphics2D brush)
	{
		if(this.rotation!=0)
		{
			brush.rotate(this.rotation, this.getCenterX(), this.getCenterY());
		}
		Font savedFont=brush.getFont();
		brush.setRenderingHint(RenderingHints.KEY_ANTIALIASING,
            RenderingHints.VALUE_ANTIALIAS_ON);
        
		brush.setFont(font);
		frc=brush.getFontRenderContext();
		 if(frc!=null && this.width==-1 && this.height==-1)  //we have a context and the variables have been not initialized yet
		 {			
			this.width=(int)this.font.getStringBounds(this.text, frc).getBounds2D().getWidth();
			this.height=(int)this.font.getStringBounds(this.text, frc).getBounds2D().getHeight();
		 }
		 brush.drawString(this.text, this.posX, this.posY);
		 brush.setFont(savedFont);
		 if(this.rotation!=0)
		{
			brush.rotate(-this.rotation, this.getCenterX(), this.getCenterY());
		}
	}
	
	public int getX()
	{
		return this.posX;
	}
	
	public int getY()
	{
		return this.posY;
	}
	
	public int getWidth()
	{
		return this.width;
	}
	
	public int getHeight()
	{
		return this.height;
	}
	
	public int getCenterX()
	{
		return this.posX+this.width/2;
	}
	
	public int getCenterY()
	{
		return this.posY+this.height/2;
	}
	
	public void setRotation(double rotation)
	{
		this.rotation=rotation;
	}
	
	public double getRotation()
	{
		return this.rotation;
	}
}
